/*
 * Project SUBool
 * Petr Kucera, 2021
 */
/**@file cardinal_opt.cpp
 * Program options related to cardinality constraints.
 */

#include "cardinal_opt.h"

SUBool::CardinalOptionsGroup::CardinalOptionsGroup()
    : OptionsGroup("Cardinality constraints"),
      mAmoEncodingOption(AmoEncoder::kKindAnnotation, "amo",
          "Which encoding to use for the at-most-one constraint.",
          kDefaultAmoEncoding),
      mExOneEncodingOption(ExOneEncoder::kKindAnnotation, "exactly-one",
          "Which encoding to use for the exactly-one constraint.",
          kDefaultExOneEncoding)
{
   Add(mAmoEncodingOption);
   Add(mExOneEncodingOption);
}

bool
SUBool::CardinalOptionsGroup::GetValues()
{
   return mAmoEncodingOption.GetValue(mAmoEncoding)
          && mExOneEncodingOption.GetValue(mExOneEncoding);
}
