/*
j* Project SUBool
 * Petr Kucera, 2017
 */
/**@file cltolit.cpp
 * Class representing data structure which represents a CNF together
 * with clauses to literals mapping and unit clauses.
 */

#include "cl2lit.h"

void
SUBool::ClausesToLiterals::Init(const CNF &cnf)
{
   mClausesToLiterals.clear();
   mUnitClauses.clear();
   mClausesToLiterals.resize(2 * cnf.MaxVariable());
   for (unsigned i = 0; i < cnf.Size(); ++i)
   {
      for (const auto &lit : cnf[i])
      {
         mClausesToLiterals[lit.Index()].push_back(i);
      }
      if (cnf[i].Size() == 1)
      {
         mUnitClauses.insert(cnf[i][0]);
      }
   }
}

const std::vector<unsigned> &
SUBool::ClausesToLiterals::Clauses(const Literal &lit) const
{
   return mClausesToLiterals[lit.Index()];
}

bool
SUBool::ClausesToLiterals::IsUnit(const Literal &lit) const
{
   return (mUnitClauses.find(lit) != mUnitClauses.end());
}

