/*
 * Project SUBool
 * Petr Kucera, 2017
 */
/**@file cltolit.h
 * Class representing data structure which represents a CNF together
 * with clauses to literals mapping and unit clauses.
 */

#ifndef __CL2LIT_H
#define __CL2LIT_H

#include <set>
#include <vector>

#include "normalform.h"

namespace SUBool
{
   class ClausesToLiterals
   {
      std::vector<std::vector<unsigned>> mClausesToLiterals;
      std::set<Literal> mUnitClauses;

    public:
      ClausesToLiterals() : mClausesToLiterals(), mUnitClauses() {}
      ClausesToLiterals(const CNF &cnf) : ClausesToLiterals() { Init(cnf); }
      void Init(const CNF &cnf);

      const std::vector<unsigned> &Clauses(const Literal &lit) const;
      bool IsUnit(const Literal &lit) const;
   };
}; // namespace SUBool

#endif
