/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file cnfcompare.h
 * Various CNF comparison related utility functions.
 */

#ifndef __CNFCOMPARE_H
#define __CNFCOMPARE_H

#include "normalform.h"

namespace SUBool
{
   enum class CompareResult
   {
      INCOMPARABLE,
      LESS,
      GREATER,
      EQUAL
   };

   bool cnf_implies(const CNF &a, const CNF &b);
   bool cnf_implies_up(const CNF &a, const CNF &b);
   bool cnf_absorbed(const CNF &a, const CNF &b);
   bool cnf_equal(const CNF &a, const CNF &b);
   bool cnf_equal_up(const CNF &a, const CNF &b);
   bool cnf_equal_absorb(const CNF &a, const CNF &b);

   CompareResult cnf_compare(const CNF &a, const CNF &b);
   CompareResult cnf_compare_up(const CNF &a, const CNF &b);
   CompareResult cnf_compare_absorb(const CNF &a, const CNF &b);

   CompareResult cmp_result_of_bool(bool leq, bool geq);
} // namespace SUBool

#endif
