/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file cpuutil.h
 * CPU time related functions.
 */

#ifndef __CPUUTIL_H
#define __CPUUTIL_H

#include <ctime>
#include <chrono>
#include <atomic>
#include <iostream>

namespace SUBool
{
   double cpu_time_since(const clock_t &c_start);

   class CPUTime
   {
      std::atomic<clock_t> mStart;

      public:
      CPUTime();

      void Reset();
      double TimeSpan() const;

   };

   class RealTime
   {
      std::atomic<std::chrono::high_resolution_clock::time_point> mStart;

      public:
      RealTime();

      void Reset();
      double Duration() const;

   };

   std::ostream &operator<<(std::ostream &out, const CPUTime &cpu_time);
   std::ostream &operator<<(std::ostream &out, const RealTime &real_time);
}

#endif
