/*
 * Project SUBool
 * Petr Kucera, 2020
 */
/**@file drenc.h
 * Functions related to dual rail encoding.
 */

#ifndef __DRENC_H
#define __DRENC_H

#include "enum.h"
#include "impl_system.h"
#include "normalform.h"

namespace SUBool
{
   enum class LIT_IMPL_SYSTEM
   {
      DRENC,
      IRREDUNDANT, // left+right
      GDBASIS,
      GDBASIS_RIGHT_IRRED,
      BODY_MINIMAL,
      BODY_MINIMAL_IRRED,
      Default = BODY_MINIMAL_IRRED
   };

   extern const EnumAnnotation<LIT_IMPL_SYSTEM> kLitImplSystemAnnotation;

   LitImplSystem init_lit_impl_system(const CNF &cnf, LIT_IMPL_SYSTEM is_kind);

   void append_clause_dual_rail(
       std::vector<LitImpl> &impl, const Clause &clause);
   LitImplSystem dual_rail(const CNF &cnf, bool merge_bodies);
   void append_clauses_of_impl(
       std::vector<Clause> &clauses, const LitImpl &impl);
   CNF dual_rail_to_cnf(const LitImplSystem &is);
   std::vector<Clause> dr_clauses_of_impl(const LitImpl &impl);

} // namespace SUBool

#endif
