/*
 * Project SUBool
 * Petr Kucera, 2016
 */
/**@file horn.h
 * Functions related to Horn functions.
 */

#ifndef __HORN_H
#define __HORN_H

#include "impl_system.h"
#include "normalform.h"

namespace SUBool
{
   bool IsDefiniteHornClause(const Clause &clause);
   bool IsHornClause(const Clause &clause);
   bool IsDefiniteHornTerm(const Term &term);
   bool IsHornTerm(const Term &term);
   bool IsAntiHornClause(const Clause &clause);
   bool IsAntiHornTerm(const Term &term);
   bool IsHornCNF(const CNF &cnf);
   bool IsHornDNF(const DNF &dnf);
   bool IsDefiniteHornCNF(const CNF &cnf);
   bool IsDefiniteHornDNF(const DNF &dnf);
   bool IsAntiHornCNF(const CNF &cnf);
   bool IsAntiHornDNF(const DNF &dnf);

   VarImpl horn_clause_to_impl(const Clause &clause);
   VarImplSystem horn_cnf_to_implsys(const CNF &cnf, bool merge_bodies);
   std::vector<Clause> impl_to_horn_clauses(const VarImpl &imp);
   CNF implsys_to_horn_cnf(const VarImplSystem &is);
   CNF horn_gd_basis(const CNF &cnf);

}; // namespace SUBool

#endif
