/*
 * Project SUBool
 * Petr Kucera, 2020
 * Jakub Rozlivek, 2020
 */
/**@file kissat_bind.cpp
 * Binding class to kissat solver library. */

#include "kissat_bind.h"

SUBool::PartialValue
SUBool::of_kissat_value(int val)
{
   if (val > 0)
   {
      return PartialValue::TRUE;
   }
   else if (val < 0)
   {
      return PartialValue::FALSE;
   }
   return PartialValue::UNDEF;
}

SUBool::Literal
SUBool::of_kissat_lit(int lit)
{
   return Literal(abs(lit), lit > 0);
}

void
SUBool::KissatSolver::Adapt(const SolverInterface::ADAPTATION adapt)
{
   switch (adapt)
   {
   case SolverInterface::ADAPTATION::LIKELY_SAT:
      kissat_set_option(solver, "target", TARGET_SAT);
      break;
   case SolverInterface::ADAPTATION::LIKELY_UNSAT:
      kissat_set_option(solver, "stable", STABLE_UNSAT);
      break;
   default:
      break;
   }
}
