/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file logstream.cpp
 * A buffer for creating a stream which discards everything and stream
 * which.
 */

#include <ctime>

#include "logstream.h"

const char *SUBool::LogStream::kMaxLogLevels = "3";
SUBool::LogStream SUBool::logs(std::cout, 0);

void
SUBool::LogStream::Set(std::ostream &out, unsigned verbosity_level)
{
   mOut = &out;
   mVerbLevel = verbosity_level;
}

std::ostream &
SUBool::LogStream::Log(unsigned level)
{
   return (CheckLevel(level) && mOut != nullptr ? *mOut : nullstream());
}

std::ostream &
SUBool::LogStream::CLog(unsigned level)
{
   return Log(level) << "c ";
}

std::ostream &
SUBool::LogStream::TLog(unsigned level)
{
   time_t t = std::time(0);
   struct tm *lt = localtime(&t);
   snprintf(mBuffer, 64, "[%02d.%02d.%d %02d:%02d:%02d] ", lt->tm_mday,
            lt->tm_mon + 1, lt->tm_year + 1900, lt->tm_hour, lt->tm_min,
            lt->tm_sec);
   return CLog(level) << mBuffer;
}
