/*
 * Project SUBool
 * Petr Kucera, 2016
 */
/**@file mrh.h
 * Algorithms for finding a maximum renamable Horn sub-CNF of a CNF.
 */

#ifndef __MRH_H
#define __MRH_H

#include "normalform.h"

namespace SUBool
{
   unsigned SimpleMRH(const CNF &cnf, Assignment *renaming);
   void SplitToRenamableHornParts(const CNF &cnf,
         std::vector< std::pair<CNF, Assignment> > *part_list);
};

#endif
