/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file nullstream.h
 * A stream which discards everything.
 */

#ifndef __NULLSTREAM_H
#define __NULLSTREAM_H

#include <sstream>

namespace SUBool
{
   class NullBuffer : public std::streambuf
   {
      public:
         int overflow(int c) { return c; }

         NullBuffer() : std::streambuf() {}
         NullBuffer(const NullBuffer &) : std::streambuf() {}
         NullBuffer(NullBuffer &&) : std::streambuf() {}
         NullBuffer &operator=(const NullBuffer &) { return *this; }
         NullBuffer &operator=(NullBuffer &&) { return *this; }
   };

   std::ostream &nullstream();
};

#endif
