/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file pccomp.h
 * A compiler into a propagation complete formula (PC).
 */

#ifndef __PCCOMP_H
#define __PCCOMP_H

#include "absinccomp.h"
#include "pcenc.h"

namespace SUBool
{
   class PCComp : public AbsIncrementalComp
   {
    public:
      using Config = BaseConfig;
      static const std::string kEmpowerMsg;
      CheckerSATTemplate<PCEncoder> mCheckerSAT;

    private:
      PCEncoder::Config mEncConf;
      Config mConf;

      virtual AbsCheckerSAT &CheckerSAT() override;
      virtual const AbsCheckerSAT &CheckerSAT() const override;
      virtual std::string PreambleGoal() const override;
      virtual std::string PreambleResultFormulaKind() const override;

    public:
      PCComp(CNF cnf, Config conf);
      virtual ~PCComp() = default;
      virtual const BaseConfig &GetBaseConfig() const override;
      virtual const std::string &EmpowerMsg() override;
   };
} // namespace SUBool

#endif
