/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file resolve.h
 * Functions and structures for algorithms related to resolution.
 */

#ifndef __RESOLVE_H
#define __RESOLVE_H

#include "nfliteralset.h"

namespace SUBool
{
   // Returns a pair of a resolvent and a variable over which the resolution was
   // performed. If the two clauses are not resolvable, 0 is returned at the
   // place of variable and the resolvent is empty.
   std::pair<Clause, unsigned> resolve(const Clause &left, const Clause &right);
   bool resolvable(const Clause &left, const Clause &right);
} // namespace SUBool

#endif
