/*
 * Project SUBool
 * Petr Kucera, 2019
 */
/**@file simple_constraints.cpp
 * Encodings of various constraints.
 */

#include "simple_constraints.h"

void
SUBool::encode_implication(const std::vector<Literal> &antecedent,
                           const std::vector<Literal> &consequent,
                           std::vector<Clause> &clauses)
{
   Clause c(antecedent);
   c.NegateLiterals();
   for (const auto &lit : consequent)
   {
      Clause cc(c);
      cc.PushBack(lit);
      clauses.push_back(std::move(cc));
   }
}

void
SUBool::encode_equivalence(const std::vector<Literal> &left,
                           const std::vector<Literal> &right,
                           std::vector<Clause> &clauses)
{
   encode_implication(left, right, clauses);
   encode_implication(right, left, clauses);
}
