/*
 * Project SUBool
 * Petr Kucera, 2017
 */
/**@file up_onelevel.h
 * One level encoding of unit propagation constraint. Only suitable
 * for checking empowerement.
 */

#ifndef __UP_ONELEVEL_H
#define __UP_ONELEVEL_H

#include "upenc.h"

namespace SUBool
{
   class UPEncOneLevel : public UPEncoder
   {
    private:
      void InitVars(std::vector<unsigned> *vars) const;

    public:
      UPEncOneLevel(
          const CNF &cnf, const ClausesToLiterals &cl2lit, VarStore &var_store)
          : UPEncoder(cnf, cl2lit, var_store)
      {
      }
      virtual void Encode(unsigned max_level, std::vector<unsigned> *inputs,
          std::vector<unsigned> *outputs,
          std::vector<Clause> *clauses) const override;
      virtual NFSize EstimateSize(unsigned max_level) const override;
      virtual unsigned MaxLevelBound() const override;
      virtual unsigned NextLevelBound(unsigned level) const override;
   };
}; // namespace SUBool

#endif
