/*
 * Project SUBool
 * Petr Kucera, 2016
 */
/**@file test_assign.h
 * Contains tests for Assignment and derived classes.
 */

#ifndef __TEST_NORMALFORM_H
#define __TEST_NORMALFORM_H

#include <vector>

#include "assign.h"

namespace SUBool
{
   class TestAssign
   {

      bool TestPartialValue() const;
      bool TestFalsePartial(unsigned n) const;
      bool TestFalseFull(unsigned n) const;
      bool TestRandomPartial(unsigned n, double p0, double p1) const;
      bool TestRandomFull(unsigned n, double p1) const;
      bool TestIncFull() const;
      bool TestIncPartial() const;

    public:
      bool RunTests() const;
   };
} // namespace SUBool

#endif
