/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file test_canon.h
 * Contains tests for canonical CNF computation.
 */

#ifndef __TEST_CANON_H
#define __TEST_CANON_H

#include <memory>

#include "canon.h"

namespace SUBool
{
   class TestCanon
   {
      enum class CanonType
      {
         BASE,
         SAT
      };

      std::unique_ptr<AbsCanon> CanonProcedure(CNF cnf,
                                               CanonType canon_type) const;
      bool IsCanonCNF(const CNF &cnf, const CNF &canonical) const;
      bool TestCanonCNF(CNF cnf, CanonType canon_type) const;
      bool TestCanonRandom(unsigned n_vars, unsigned n_clauses,
                           unsigned n_tests, CanonType canon_type) const;

    public:
      bool RunTests() const;
   };
} // namespace SUBool

#endif
