/*
 * Project SUBool
 * Petr Kucera, 2019
 */
/**@file test_cardinal.h
 * Contains tests for encodings of cardinality constraints.
 */

#ifndef __TEST_CARDINAL_H
#define __TEST_CARDINAL_H

#include "cardinal.h"
#include "encoding.h"
#include "logstream.h"
#include "random_utils.h"

namespace SUBool
{
   class TestCardinal
   {
      bool TestAmoMostNegatives(const CNFEncoding &enc,
                                const std::vector<Literal> &inputs) const;
      bool TestExOneMostNegatives(const CNFEncoding &enc,
                                  const std::vector<Literal> &inputs) const;
      bool TestFewNegatives(const CNFEncoding &enc,
                            const std::vector<Literal> &inputs) const;
      bool TestTwoPositive(const CNFEncoding &enc,
                           const std::vector<Literal> &inputs) const;
      bool TestSinglePositive(const CNFEncoding &enc,
                              const std::vector<Literal> &inputs) const;
      bool TestAmoEncoding(const CNFEncoding &enc,
                           const std::vector<Literal> &inputs) const;
      bool TestExOneEncoding(const CNFEncoding &enc,
                             const std::vector<Literal> &inputs) const;
      bool TestAmoRepresentation(unsigned n) const;
      bool TestExOneRepresentation(unsigned n) const;
      bool TestAmoSequential(unsigned n) const;
      bool TestExOneSplitting(unsigned n) const;
      bool TestSize(unsigned n, const CNFEncoding &enc,
                    const ConstraintEncoder &encoder) const;

    public:
      bool RunTests() const;
   };
} // namespace SUBool

#endif
