/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file test_cnfutil.h
 * Contains tests for various functions defined in cnfutil.
 */

#ifndef __TEST_CNFUTIL_H
#define __TEST_CNFUTIL_H

#include "cnfutil.h"

namespace SUBool
{
   class TestCNFUtil
   {
      bool TestMinimalSubimplicantCNF(const CNF &cnf,
                                      const Assignment &model) const;
      bool TestMinimalSubimplicantCNFFixed(const CNF &cnf,
                                           const Assignment &model) const;
      bool TestMinimalSubimplicant(unsigned n_vars, unsigned n_clauses,
                                   unsigned n_tests) const;
      bool TestMinimalSubimplicantFixed(unsigned n_vars, unsigned n_clauses,
                                        unsigned n_tests) const;
      bool TestPrimeSubimplicate(const CNF &cnf, const Clause &clause) const;
      bool TestPrimeSubimplicates(unsigned n_rounds,
                                  unsigned n_checks_per_round, unsigned n_vars,
                                  unsigned n_clauses) const;
      bool TestPrimeCNF(const CNF &cnf) const;
      bool TestPrimeRandomCNFs(unsigned n_rounds, unsigned n_vars,
                               unsigned n_clauses) const;

    public:
      bool RunTests() const;
   };
} // namespace SUBool

#endif
