/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file test_dnnf.h
 * Contains tests for DNNF encoding and other related stuff.
 */

#ifndef __TEST_DNNF_H
#define __TEST_DNNF_H

#include "dnnf_enc.h"

namespace SUBool
{
   class TestDnnf
   {
      bool TestDnnfInputUrcEncoder() const;
      bool TestSmoothDnnfInputPcEncoder() const;
      bool TestEliminationOnPCE(const char *nnf_str, const char *cnf_str) const;
      bool TestDnnfUrcWithDecisions() const;
      bool TestSmoothDnnfPcWithDecisions() const;
      bool TestMonotoneX() const;
      bool TestSmoothDnnfPc(const char *dnnf_string,
                            const char *cnf_string) const;
      bool TestTopologicalOrderVisitor(const char *dnnf_string) const;
      bool TestSmoothDnnfPcEncoder(LEVEL_FUNC level_func) const;
      bool TestSmoothDnnfUrcEncoder(LEVEL_FUNC level_func) const;

      bool TestDnnfEquivalence(const char *dnnf_str, const char *cnf_str) const;

    public:
      bool RunTests() const;
   };
} // namespace SUBool

#endif
