/*
 * Project SUBool
 * Petr Kucera, 2020
 */
/**@file test_empower2.h
 * Contains tests of OneProveM.
 */

#ifndef __TEST_EMPOWER2_H
#define __TEST_EMPOWER2_H

#include "normalform.h"

namespace SUBool
{
   class TestOneProveM
   {
      bool TestSingleRandomCNF(const CNF &cnf, const unsigned clause_rounds,
                               const unsigned clause_size) const;
      bool TestMinimizeFull(const CNF &cnf) const;
      bool TestMinimizeIncremental(const CNF &cnf, bool reprocess) const;
      bool TestRandomCNF(const unsigned rounds, const unsigned n_clauses,
                         const unsigned n_vars, const unsigned clause_rounds,
                         const unsigned clause_size) const;

    public:
      bool RunTests() const;
   };
}; // namespace SUBool

#endif
