/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file test_encoding.h
 * Contains tests for CNF encoding representation.
 */

#ifndef __TEST_ENCODING_H
#define __TEST_ENCODING_H

#include "encoding.h"

namespace SUBool
{
   class TestEncoding
   {
      bool TestSimpleSATEncoding() const;
      bool TestSATEncoding(unsigned n_rounds, unsigned n_clauses,
                           unsigned n_vars) const;
      bool TestSATEncodingConsistencyFull(const CNFEncoding &enc,
                                          const CNF &cnf) const;
      bool TestSATEncodingConsistencyPartial(const CNFEncoding &enc,
                                             const CNF &cnf) const;
      bool TestSATEncodingPropagation(const CNFEncoding &enc,
                                      const CNF &cnf) const;
      bool TestURCEncoding(unsigned n_rounds) const;
      bool TestAssignment(const Assignment &alpha,
                          const CNFEncoding &ref_encoding,
                          const CNFEncoding &check_encoding) const;
      bool TestPartialAssignment(const PartialAssignment &alpha,
                                 const CNFEncoding &ref_encoding,
                                 const CNFEncoding &check_encoding) const;
      bool TestEliminateAuxVariable(unsigned n_rounds) const;
      bool TestRead() const;

    public:
      bool RunTests() const;
   };
} // namespace SUBool

#endif
