/*
 * Project SUBool
 * Petr Kucera, 2017
 */
/**@file test_glucose.h
 * Test connection to glucose library.
 */

#ifndef __TEST_GLUCOSE_H
#define __TEST_GLUCOSE_H

#include <string>

#include "normalform.h"

namespace SUBool
{
   class TestGlucose
   {
      bool TestSimple() const;
      bool TestLearntsRandom(const unsigned nrounds, const unsigned nclauses,
                             const unsigned clause_size,
                             const unsigned nvars) const;
      bool TestConflict(const CNF &cnf,
                        const std::vector<Literal> &assumptions) const;
      bool TestConflicts(const unsigned nrounds,
                         const unsigned nconflicts_per_round,
                         const unsigned nvars, const unsigned nclauses) const;
      bool TestIncrementalSimple() const;
      bool TestIncremental(const unsigned n_rounds, const unsigned n_clauses,
                           const unsigned n_vars,
                           const unsigned assump_length) const;

    public:
      bool RunTests() const;
   };
}; // namespace SUBool

#endif
