/*
 * Project SUBool
 * Petr Kucera, 2016
 */
/**@file test_horn.h
 * Contains tests for functions related to Horn functions.
 */

#ifndef __TEST_HORN_H
#define __TEST_HORN_H

#include "assign.h"

namespace SUBool
{
   class TestHorn
   {
      bool TestHornCNFCheck(const char *dimacs, bool is_horn) const;
      bool TestAntiHornCNFCheck(const char *dimacs, bool is_horn) const;
      /*bool TestHornDNFCheck(const char *dimacs, bool is_horn) const;
      bool TestAntiHornDNFCheck(const char *dimacs, bool is_horn) const;*/
      bool TestRenamableHornCheck() const;
      bool TestRenamableHornCheckNegative() const;
      bool TestSimpleMRH() const;
      bool TestRHornSplit() const;

    public:
      TestHorn();
      bool RunTests() const;
   };
}; // namespace SUBool

#endif
