/*
 * Project SUBool
 * Petr Kucera, 2017
 */
/**@file test_kissat.h
 * Test connection to kissat library.
 */

#ifndef __TEST_KISSAT_H
#define __TEST_KISSAT_H

#include <string>

#include "normalform.h"

namespace SUBool
{
   class TestKissat
   {
      bool TestSimple() const;
      bool TestLearntsRandom(const unsigned nrounds, const unsigned nclauses,
                             const unsigned clause_size,
                             const unsigned nvars) const;
      bool TestConflict(const CNF &cnf,
                        const std::vector<Literal> &assumptions) const;
      bool TestConflicts(const unsigned nrounds,
                         const unsigned nconflicts_per_round,
                         const unsigned nvars, const unsigned nclauses) const;

    public:
      bool RunTests() const;
   };
}; // namespace SUBool

#endif
