/*
 * Project SUBool
 * Petr Kucera, 2016
 */
/**@file test_nfliteralset.h
 * Contains tests for NFLiteralSet
 */

#ifndef __TEST_NFLITERALSET_H
#define __TEST_NFLITERALSET_H

#include <vector>

#include "nfliteralset.h"

namespace SUBool
{
   class TestNFLiteralSet
   {
      bool TestDeterminingValue(bool value) const;
      bool TestClauseDeterminingValue() const;
      bool TestTermDeterminingValue() const;
      bool TestDIMACS() const;

      bool TestClauseSize() const;
      bool TestLiteralAccess() const;
      bool TestEvaluationSimple() const;
      bool TestEvaluationRandom() const;

      bool TestLiteralSetPolarities() const;
      bool TestApplyRenamingToLiteralSet() const;
      bool TestApply(
            const PartialAssignment &alpha,
            const Clause &a, const Clause &b,
            PartialValue res) const;
      bool TestApply() const;

      bool TestSubsetComparison() const;
      bool TestLT(const Clause &a, const Clause &b,
            bool result) const;
      bool TestGT(const Clause &a, const Clause &b,
            bool result) const;
      bool TestLE(const Clause &a, const Clause &b,
            bool result) const;
      bool TestGE(const Clause &a, const Clause &b,
            bool result) const;
      bool TestCompare(const Clause &a, const Clause &b,
            int result) const;
      bool TestComparison() const;
      bool TestNegateLiterals() const;
      bool TestPushback() const;

      public:
      bool RunTests() const;
   };
};

#endif
