/*
 * Project SUBool
 * Petr Kucera, 2018
 */
/**@file test_nnftraits.h
 * Contains tests for nnf traits checking and manipulation (defined in dnnf).
 */

#ifndef __TEST_NNFTRAITS_H
#define __TEST_NNFTRAITS_H

#include <unordered_set>

#include "literal.h"

namespace SUBool
{
   class TestNnfTraits
   {
      bool TestNnfTraitsCheck() const;
      bool TestNnfTraitsCheck(const char *nnf_string, bool decomposable,
                              bool smooth, bool decision_nnf) const;
      bool TestNnfLiteralNodes(
          const char *nnf_string,
          const std::unordered_set<Literal> &literal_nodes) const;
      bool TestNnfLiteralNodes() const;
      bool TestNnfSmooth(const char *nnf_string) const;
      bool TestNnfSmooth() const;

    public:
      bool RunTests() const;
   };
} // namespace SUBool

#endif
