/*
 * Project SUBool
 * Petr Kucera, 2016
 */
/**@file test_normalform.h
 * Contains tests for NormalForm
 */

#ifndef __TEST_NORMALFORM_H
#define __TEST_NORMALFORM_H

#include <string>
#include <vector>

#include "normalform.h"

namespace SUBool
{
   class TestNormalForm
   {
      bool TestCNFDeterminingValue() const;
      bool TestDNFDeterminingValue() const;
      bool TestDIMACSSimple() const;
      bool TestDIMACSQuinn() const;
      bool TestClauseAccess() const;
      bool TestEvaluationSimple() const;
      bool TestApplyRenamingWithDIMACS(const char *dimacs,
                                       const Assignment &renaming) const;
      bool TestApplyRenaming() const;
      bool TestApply(const PartialAssignment &alpha,
                     const std::string &dimacs_in,
                     const std::string &dimacs_out, PartialValue val) const;
      bool TestApply() const;
      bool TestSubsumptions() const;
      bool TestRemoveDuplicities() const;
      bool TestSort() const;

    public:
      bool RunTests() const;
   };
} // namespace SUBool

#endif
