/*
 * Project SUBool
 * Petr Kucera, 2019
 */
/**@file test_prob.cpp
 * Contains a simple program for testing probabilistic distributions.
 */

#include <chrono>
#include <iostream>
#include <random>

void
geometric(unsigned n, unsigned rounds, double p)
{
   std::mt19937_64 generator(
       std::chrono::system_clock::now().time_since_epoch().count());
   std::geometric_distribution<unsigned> gd(p);
   std::vector<unsigned> freq(n + 1, 0);
   while (rounds > 0)
   {
      --rounds;
      auto val = std::min(n, gd(generator));
      ++freq[val];
   }
   for (unsigned i = 0; i < freq.size(); ++i)
   {
      std::cout << i << " " << freq[i] << std::endl;
   }
}

int
main(int /*argc*/, char * /*argv*/[])
{
   geometric(500, 10000, 5.0 / 500.0);
   return 0;
}

