/*
 * Project SUBool
 * Petr Kucera, 2020
 */
/**@file test_propagate.h
 * Contains tests for semantic propagation.
 */
#ifndef __TEST_PROPAGATE_H
#define __TEST_PROPAGATE_H

#include "cpuutil.h"
#include "propagate.h"

namespace SUBool
{
   class TestPropagate
   {
      bool TestSimpleSATPropagation() const;
      bool TestPropagatorWithAssumptions(const CNF &cnf, AbsPropagator &prop,
                                         const PartialAssignment &alpha) const;
      bool TestRandomCNFPropagation(const unsigned n_rounds,
                                    const unsigned n_clauses,
                                    const unsigned n_vars,
                                    const unsigned n_assump_rounds,
                                    const double assump_prob_false,
                                    const double assump_prob_true) const;
      double
      TimeOfCNFPropagation(AbsPropagator &prop,
                           const std::vector<PartialAssignment> &alpha) const;
      bool CheckTimes() const;

    public:
      bool RunTests() const;
   };
} // namespace SUBool

#endif
