/*
 * Project SUBool
 * Petr Kucera, 2019
 */
/**@file test_upenc.h
 * Contains tests for UPEncoder descendants, size estimates.
 */

#ifndef __TEST_UPENC_H
#define __TEST_UPENC_H

#include "up_log.h"
#include "up_quad.h"
#include "upenc.h"

namespace SUBool
{
   class TestUPEncoder
   {
      bool TestSizeEstimateOfEncoderWithLevel(
          const UPEncoder &enc, unsigned max_level) const;
      bool TestSizeEstimateOfEncoder(
          const UPEncoder &enc, VarStore &var_store) const;
      bool TestSizeEstimateQuad(
          UPEncQuad::DIRECTION direction, const CNF &cnf) const;
      bool TestSizeEstimateQuadImpl(const CNF &cnf) const;
      bool TestSizeEstimateImplLevel(const CNF &cnf) const;
      bool TestSizeEstimateOneLevel(const CNF &cnf) const;
      bool TestSizeEstimateLogarithmic(
          const CNF &cnf, const UPEncLogarithmic::Config &conf) const;
      bool TestSizeEstimateMinLQ(const CNF &cnf, bool literal_levels) const;
      bool TestSizeEstimateSCCUnary(
          const CNF &cnf, LIT_IMPL_SYSTEM is_type) const;
      bool TestSizeEstimateSCCBinary(
          const CNF &cnf, bool use_bit_level, LIT_IMPL_SYSTEM is_type) const;
      bool TestSizeEstimateSCCBinaryDirect(
          const CNF &cnf, bool use_bit_level, LIT_IMPL_SYSTEM is_type) const;
      bool TestSizeEstimateForCNF(const CNF &cnf) const;
      bool TestSizeEstimate(
          unsigned n_rounds, unsigned n_vars, unsigned n_clauses) const;

    public:
      bool RunTests() const;
   };
} // namespace SUBool

#endif

